#include "ai8051u.h" 			//调用头文件
#include "stc32_stc8_usb.h"		//USB CDC 头文件
#include "intrins.h"            //调用头文件

#define u8 unsigned char
#define u16 unsigned int

char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";

u8 state = 0;					//初始状态为0
u8 Run_State = 0; 				//运行状态

void Delay20ms(void)	//@24.000MHz delay20ms Delay20ms();
{
	unsigned long edata i;

	_nop_();
	_nop_();
	i = 119998UL;
	while (i) i--;
}

void Timer0_Init(void);			//函数声明

void main (void)				//主函数
{  
	int count = 1;				//按键计数
	
    WTST = 0;  					//设置程序指令延时参数，赋值为0可将CPU执行指令的速度设置为最快
    EAXFR = 1; 					//扩展寄存器(XFR)访问使能
    CKCON = 0; 					//提高访问XRAM速度
	
	P_SW2 |= 0x80;              //B7位置1，使能访问XFR寄存器
	
	P0M0 = 0x00; P0M1 = 0x00; 	
    P1M0 = 0x00; P1M1 = 0x00; 
    P2M0 = 0x00; P2M1 = 0x00; 
    P3M0 = 0x00; P3M1 = 0x00; 
    P4M0 = 0x00; P4M1 = 0x00; 
    P5M0 = 0x00; P5M1 = 0x00; 
    P6M0 = 0x00; P6M1 = 0x00; 
    P7M0 = 0x00; P7M1 = 0x00; 	//将所有的端口都设置成准双向口，方便后期的使用。

	usb_init();					//USB CDC 接口配置
	
	IE2 |= 0x80;                //使能USB中断
	
//	Timer0_Init();				//定时器初始化
	
    EA = 1; 					//EA |= 0X80;
	
	while (DeviceState != DEVSTATE_CONFIGURED);     //等待USB完成配置
	
    while (1)
    {
        if (bUsbOutReady)					//如果接收到了一个数据
        {
            //USB_SendData(UsbOutBuffer,OutNumber);   //发送数据缓冲区，长度（接收数据原样返回, 用于测试）

            usb_OUT_done();					//清除当前的接收区
        }

//		任务一：
//		if(P33 == 0)
//		{
//			Delay20ms();				//消抖
//			if(P33 == 0)
//			{
//				printf("按键按下次数:%d 次\r\n",count);
//				count ++;
//			}
//			while(P33 == 0);			//判断按键状态是不是改变了
//		}
		
		//任务2：
//		if(P33 == 0)
//		{
//			Delay20ms();				//消抖
//			if(P33 == 0)
//			{
////				printf("按键按下次数:%d 次\r\n",count);
////				count ++;
//				P00 = 0;
//			}
//			while(P33 == 0);			//判断按键状态是不是改变了
//		}
		
		//任务3：救护车灯控制器，按下报警按钮，红蓝交替闪烁（LED1和LED2 表示红、蓝灯），再按下报警按钮，红蓝灯停止。
		if(P33 == 0)
		{
			Delay20ms();				//消抖
			if(P33 == 0)
			{
				Run_State = !Run_State;
				if(Run_State == 1)		//运行
				{
					Timer0_Init();		//启动定时器
					printf("启动定时器!\r\n");
				}
				else
				{
					TR0 = 0;			//关闭定时器
					P00 = 1;
					P01 = 1;			//关灯
					printf("关闭定时器，同时关灯!\r\n");
				}
				P00 = 0;
			}
			while(P33 == 0);			//判断按键状态是不是改变了
		}
		
	}
}

//函数定义
void Timer0_Init(void)		//500毫秒@24.000MHz
{
	TM0PS = 0x0F;			//设置定时器时钟预分频 ( 注意:并非所有系列都有此寄存器,详情请查看数据手册 )
	AUXR &= 0x7F;			//定时器时钟12T模式
	TMOD &= 0xF0;			//设置定时器模式
	TL0 = 0xDC;				//设置定时初始值
	TH0 = 0x0B;				//设置定时初始值
	TF0 = 0;				//清除TF0标志
	TR0 = 1;				//定时器0开始计时
	ET0 = 1;				//使能定时器0中断
}

//void Timer0_Init(void)		//3秒@24.000MHz
//{
//	TM0PS = 0x5B;			//设置定时器时钟预分频 ( 注意:并非所有系列都有此寄存器,详情请查看数据手册 )/*	91分频。*/
//	AUXR &= 0x7F;			//定时器时钟12T模式  /*	最高位清零了。*/
//	TMOD &= 0xF0;			//设置定时器模式
//	TL0 = 0x3F;				//设置定时初始值
//	TH0 = 0x01;				//设置定时初始值
//	TF0 = 0;				//清除TF0标志
//	TR0 = 1;				//定时器0开始计时
//	ET0 = 1;				//使能定时器0中断
//	
//	//TMOPS = 91
//	//12T模式
//	//TMOD低四位清零，配置定时器模式
//	//TH0-TL0 = 319
//	//TF0 = 0，先清零，防止上电就进中断了。
//	//TR0 = 1，开始计时
//	//ET0 = 1;	就是开启其中断
//}

void Timer0_Isr(void) interrupt 1  			//三秒钟执行一次。
{
	state = !state;
	P00 = state;
	printf("P00 = %d\r\n",state);
	P01 = !state;
	printf("P01 = %d\r\n",!state);
}

		